<?php
/*
	Copyright(c) 2010 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once (LIB_PATH.'/common/unitCommon.php');
require_once (LIB_PATH.'/common/imgmngrDB.php');

class extImg extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_img"; 			//公開用テーブル名
	var $_tmptable = "extunit_img_tmp"; //下書き用テーブル名
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//
					array("column"=>"extimg_img1","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"extimg_img2","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"extimg_img1_sp","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"extimg_img2_sp","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"extimg_img_code1","conv"=>"a","tags"=>false),		//オリジナル画像ファイルID
					array("column"=>"extimg_img_code2","conv"=>"a","tags"=>false),		//オリジナル画像ファイルID
					array("column"=>"extimg_img_code1_sp","conv"=>"a","tags"=>false),		//オリジナル画像ファイルID
					array("column"=>"extimg_img_code2_sp","conv"=>"a","tags"=>false),		//オリジナル画像ファイルID
					array("column"=>"extimg_alt","conv"=>"KV","tags"=>false),		//ALT
					array("column"=>"extimg_cap","conv"=>"KV","tags"=>false),		//キャプション
					array("column"=>"extimg_clc_flg","conv"=>"n","tags"=>false),	//クリック時の動作
					array("column"=>"extimg_jmp_url","conv"=>"a","tags"=>false),	//リンク先URL
					array("column"=>"extimg_jmp_flg","conv"=>"n","tags"=>false),	//リンク方法
					array("column"=>"btm_padding","conv"=>"n","tags"=>false),	//下方スペース
					array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),	//下方スペース
					array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)			//スマホ表示フラグ
					);
	var $jflg = array(1=>" target=\"_blank\"", 2=>"", 3=>" target=\"_top\"");
	var $_data = array();

	function extImg()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
		//整形の必要あれば・・・・
		//ここでやってください。
		$this->_data = $this->getDetail();
		if ($this->_data) {
			if(defined("SP_FLG") && SP_FLG == SP_FLG_CODE){
				//画像パス
				if($this->_data['extimg_img1_sp']) $this->_data['extimg_img1'] = $this->_data['extimg_img1_sp'];
				if($this->_data['extimg_img2_sp']) $this->_data['extimg_img2'] = $this->_data['extimg_img2_sp'];
				if(is_numeric($this->_data["btm_padding_sp"])) $this->_data["btm_padding"] = $this->_data["btm_padding_sp"];
			}
			//画像パス
			$this->_data['path1'] = UNITS_IMG_PATH.$this->_data['extimg_img1'];
			$this->_data['path2'] = UNITS_IMG_PATH.$this->_data['extimg_img2'];
			//aタグ
			$this->_data['a1'] = '';
			$this->_data['a2'] = '';
			if(file_exists(BASE_PATH.$this->_data['path2']) && is_file(BASE_PATH.$this->_data['path2'])) {
				list($wth, $hgt, $type, $attr) = getimagesize(BASE_PATH.UNITS_IMG_PATH.$this->_data['extimg_img2']);
			}

			if ($this->_data['extimg_clc_flg']!=0) {
				switch ($this->_data['extimg_clc_flg']) {
					case 1:
						$this->_data['a1'] = "<a href=\"javascript:void(0);\" onClick=\"window.open('".$this->_current_topurl.$this->_data['path2']."', null, 'width=".$wth.",height=".$hgt."');\">";
						break;
					case 2:
						$this->_data['a1'] = "<a href=\"".$this->_current_topurl.$this->_data['path2']."\" rel=\"lightbox[ligthbox]\"".$this->jflg[$this->_data['extimg_jmp_flg']].">";
						break;
					case 3:
						//$this->_data['a1'] = "<a href=\"".$this->_data['extimg_jmp_url']."\"".$this->jflg[$this->_data['extimg_jmp_flg']].">";
						break;
					default:
				}
				$this->_data['a2'] = '</a>';
			}
		}
		return $this->_data;
	}

	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$rtn =  null;
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			if($result){
				$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
			}
		}
		return $rtn;
	}


	function setDefault()
	{
		$this->_form->setDefaults(array('extimg_clc_flg'=>0));
		$data = $this->getDetail();
		if(!$data['extimg_clc_flg']){
			$data['extimg_clc_flg'] = 1;
		}
		$this->_form->setDefaults($data);
		if ($data['extimg_img1']) {
			$this->_view->assign('image1', BINGOTOPURL.UNITS_IMG_PATH.$data['extimg_img1']);
		}
		if ($data['extimg_img2']) {
			$this->_view->assign('image2', BINGOTOPURL.UNITS_IMG_PATH.$data['extimg_img2']);
		}
		if ($data['extimg_img1_sp']) {
			$this->_view->assign('image1_sp', BINGOTOPURL.UNITS_IMG_PATH.$data['extimg_img1_sp']);
		}
		if ($data['extimg_img2_sp']) {
			$this->_view->assign('image2_sp', BINGOTOPURL.UNITS_IMG_PATH.$data['extimg_img2_sp']);
		}
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
		$this->_form->addElement('hidden','extimg_img1', null,array("id"=>"extimg_img1"));
		$this->_form->addElement('hidden','extimg_img2', null,array("id"=>"extimg_img2"));
		$this->_form->addElement('hidden','extimg_img1_sp', null,array("id"=>"extimg_img1_sp"));
		$this->_form->addElement('hidden','extimg_img2_sp', null,array("id"=>"extimg_img2_sp"));
		$this->_form->addElement('file', 'picture1', '');//画像アップ用ボタン
		$this->_form->addElement('file', 'picture2', '');//画像アップ用ボタン
		$this->_form->addElement('file', 'picture3', '');//画像アップ用ボタン
		$this->_form->addElement('file', 'picture4', '');//画像アップ用ボタン
		$this->_form->addElement('text','extimg_alt', null, array('id'=>'extimg_alt','size'=>40,'maxlength' => 200));
		$this->_form->addElement('text','extimg_cap', null, array('id'=>'extimg_cap','size'=>40,'maxlength' => 200));
		$tmp = array();
		$tmp[] = $this->_form->createElement('radio', null, null, _gettext('B_P00682'), 1);
		$tmp[] = $this->_form->createElement('radio', null, null, _gettext('B_P00683'), 2);
		$this->_form->addGroup($tmp, 'extimg_clc_flg', array('id'=>'extimg_clc_flg'));
		$this->_form->addElement('text','extimg_jmp_url', null, array('id'=>'extimg_jmp_url','size'=>40,'maxlength' => 200,'style'=>'ime-mode:disabled'));
		$sel01 =& $this->_form->addElement('select','extimg_jmp_flg', array('id'=>'extimg_jmp_flg'), null);
		$sel01->addOption(_gettext('B_P00659'), 1);
		$sel01->addOption(_gettext('B_P00660'), 2);
		//表示中の画像サイズ
		$imgs_str = isset($_REQUEST["imgs"]) ? $_REQUEST["imgs"] : null;
		$this->_form->addElement('hidden','imgs', $imgs_str, array("id"=>"imgs"));

		$data = $this->getDetail();
		if(empty($data) || LICENSE::getMode()==1){
				$this->_form->addElement("hidden", "autoregister1", 1);
				$this->_form->addElement("hidden", "autoregister2", 1);
		}else{
			$this->_form->setDefaults(array("autoregister1"=>1, "autoregister2"=>1));
			$this->_form->addElement("advcheckbox", "autoregister1", null, _gettext("B_P00940"), array(), array(0,1));
			$this->_form->addElement("advcheckbox", "autoregister2", null, _gettext("B_P00940"), array(), array(0,1));
		}
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings(_gettext('B_P00472'),'');
		$this->_form->addRule('pageu_code',_gettext('B_P00643'),'required',null,$this->erchk);
		$obj = $this->_form->getElement("extimg_img1");
		$obj = $this->_form->getElement("extimg_img2");
		if (!$obj->getValue()) {
			$this->_form->addRule('picture1', '・「画像」を選択してください。','uploadedfile',null,'server');
			$this->_form->addRule('picture2', '・「拡大画像」を選択してください。','uploadedfile',null,'server');
		}
		/* v1.3
		else {
			//$this->_view->assign('image', BINGOTOPURL.UNITS_IMG_PATH.$obj->getValue());
		}
		*/
		$this->_form->addRule('picture1',_gettext('B_P00636',MAX_FILE_SIZE/(1000*1000)),'maxfilesize',MAX_FILE_SIZE,null,'server');
		$this->_form->addRule('picture1',_gettext('B_P00171'),'mimetype',array("image/pjpeg","image/jpeg","image/gif","image/x-png","image/png"));
		$this->_form->addRule('picture2',_gettext('B_P00636',MAX_FILE_SIZE/(1000*1000)),'maxfilesize',MAX_FILE_SIZE,null,'server');
		$this->_form->addRule('picture2',_gettext('B_P00171'),'mimetype',array("image/pjpeg","image/jpeg","image/gif","image/x-png","image/png"));
		//URL（入力がある場合のみチェック）
		$this->_form->registerRule('check_url', 'callback', 'check_url');
		//リンク指定の場合URLは必須
		$obj2 = $this->_form->getElement("extimg_clc_flg");
		if ($obj2->getValue()==3) {
			$this->_form->addRule( 'extimg_jmp_url', _gettext('B_P00645'), 'check_url',null,'server');
			$this->_form->addRule('extimg_jmp_url',_gettext('B_P00647'),'required',null,$this->erchk);
		}
	}

	//データ下書き保存処理
	function doSave($post)
	{
		//あらかじめ画像処理
		$result = null;
		$bimg = '';
		//既存データがあるか確認（画像削除用にも使用）
		$old_data = $this->getDetail();

		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			} else {
				$record[$val["column"]] = null;
			}
		}

		unset($record["extimg_img_code1"]);
		unset($record["extimg_img_code2"]);
		unset($record["extimg_img_code1_sp"]);
		unset($record["extimg_img_code2_sp"]);

		// ここでDBに登録する画像情報を公開用の画像情報に設定する
		// 画像を差し替えた場合（たとえ同じ画像でも）、extimg_img には数値が入ってくる為、これを判定条件とする
		if(is_numeric($record["extimg_img1"])) {
			$tmp_img1_sp = $record["extimg_img1"];
			$record["extimg_img_code1"] = $record["extimg_img1"];
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('extimg_img1',array('value' => $old_data['extimg_img1']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["extimg_img1"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path1 = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path1 = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["extimg_img1"] = array_pop(explode('/',$img_path1)); //保存ファイル名取得
				$cpflg1 = true;
			}else{
				return _gettext('B_P00651');
			}
		}
		if(is_numeric($record["extimg_img2"])) {
			$tmp_img2_sp = $record["extimg_img2"];
			$record["extimg_img_code2"] = $record["extimg_img2"];
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('extimg_img2',array('value' => $old_data['extimg_img2']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["extimg_img2"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path2 = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path2 = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["extimg_img2"] = array_pop(explode('/',$img_path2)); //保存ファイル名取得
				$cpflg2 = true;
			}else{
				return _gettext('B_P00651');
			}
		}


		if(empty($record["extimg_img1_sp"]) || $_REQUEST["autoregister1"] == 1) {
			if(is_numeric($tmp_img1_sp)){
				$record["extimg_img1_sp"] = $tmp_img1_sp;
				$record["extimg_img_code1_sp"] = $tmp_img1_sp;
				// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
				// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
				if(is_array($old_data)&& count($old_data)>0){
					$this->_form->updateElementAttr('extimg_img1_sp',array('value' => $old_data['extimg_img1_sp']));
				}
				$imgmngrDB = new imgmngrDB();
				$imgdata = $imgmngrDB->getImageFromCode($record["extimg_img1_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
				if(isset($imgdata)){
					$data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
					$img_path1_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
					$record["extimg_img1_sp"] = array_pop(explode('/',$img_path1_sp)); //保存ファイル名取得
					$cpflg1_sp = true;
				}else{
					$errstr = _gettext('B_P00701');
				}
			}else{
				$record["extimg_img1_sp"] = $record["extimg_img1"];
			}
		}else if(is_numeric($record["extimg_img1_sp"])) {
			$record["extimg_img_code1_sp"] = $record["extimg_img1_sp"];
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('extimg_img1_sp',array('value' => $old_data['extimg_img1_sp']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["extimg_img1_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path1_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path1_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["extimg_img1_sp"] = array_pop(explode('/',$img_path1_sp)); //保存ファイル名取得
				$cpflg1_sp = true;
			}else{
				$errstr = _gettext('B_P00701');
			}
		}


		if(empty($record["extimg_img2_sp"]) || $_REQUEST["autoregister2"] == 1) {
			if(is_numeric($tmp_img2_sp)){
				$record["extimg_img2_sp"] = $tmp_img2_sp;
				$record["extimg_img_code2_sp"] = $tmp_img2_sp;
				// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
				// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
				if(is_array($old_data)&& count($old_data)>0){
					$this->_form->updateElementAttr('extimg_img2_sp',array('value' => $old_data['extimg_img2_sp']));
				}
				$imgmngrDB = new imgmngrDB();
				$imgdata = $imgmngrDB->getImageFromCode($record["extimg_img2_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
				if(isset($imgdata)){
					$data_path2_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
					$img_path2_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
					$record["extimg_img2_sp"] = array_pop(explode('/',$img_path2_sp)); //保存ファイル名取得
					$cpflg2_sp = true;
				}else{
					$errstr = _gettext('B_P00701');
				}
			}else{
				$record["extimg_img2_sp"] = $record["extimg_img2"];
			}
		}else if(is_numeric($record["extimg_img2_sp"])) {
			$record["extimg_img_code2_sp"] = $record["extimg_img2_sp"];
			// ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
			// 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
			if(is_array($old_data)&& count($old_data)>0){
				$this->_form->updateElementAttr('extimg_img2_sp',array('value' => $old_data['extimg_img2_sp']));
			}
			$imgmngrDB = new imgmngrDB();
			$imgdata = $imgmngrDB->getImageFromCode($record["extimg_img2_sp"], UNITS_IMG_PATH, $record["pageu_code"], 1);
			if(isset($imgdata)){
				$data_path2_sp = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
				$img_path2_sp = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
				$record["extimg_img2_sp"] = array_pop(explode('/',$img_path2_sp)); //保存ファイル名取得
				$cpflg2_sp = true;
			}else{
				$errstr = _gettext('B_P00701');
			}
		}

		//URL指定のない場合は保存しない
		if ($record["extimg_clc_flg"]!=3) {
			$record["extimg_jmp_url"]='';
			$record["extimg_jmp_flg"]=1;
		}
		$this->db->query('BEGIN');
		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return _gettext('B_P00209');
			}
		}

		// saas
		$fsize = array();
		if($cpflg1) $fsize[] = array('size' => filesize(BASE_PATH.$data_path1));
		if($cpflg2) $fsize[] = array('size' => filesize(BASE_PATH.$data_path2));
		if($cpflg1_sp) $fsize[] = array('size' => filesize(BASE_PATH.$data_path1_sp));
		if($cpflg2_sp) $fsize[] = array('size' => filesize(BASE_PATH.$data_path2_sp));
		if (count($fsize)>0 && !commonFile::chkSaveFiles($fsize)) {
			$this->db->query('ROLLBACK');
			return _gettext('B_P00281');
		}

		// ここでファイルのコピーを行う
		if($cpflg1) {
			if(!@copy(BASE_PATH.$data_path1, BASE_PATH.$img_path1)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path1, 0666);
			}
		}
		if($cpflg2) {
			if(!@copy(BASE_PATH.$data_path2, BASE_PATH.$img_path2)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path2, 0666);
			}
		}
		if($cpflg1_sp) {
			//スマホ用はリサイズして保存
			if(!commonFIle::ImgResize(BASE_PATH.$data_path1_sp, BASE_PATH.$img_path1_sp, $new_w=DEFAULT_SPIMG_W*2, null, false)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path1_sp, 0666);
			}
		}
		if($cpflg2_sp) {
			//スマホ用はリサイズして保存
			if(!commonFIle::ImgResize(BASE_PATH.$data_path2_sp, BASE_PATH.$img_path2_sp, $new_w=DEFAULT_SPIMG_W*2, null, false)){
				$this->db->query('ROLLBACK');
				return _gettext('B_P00650');
			} else {
				@chmod(BASE_PATH.$img_path2_sp, 0666);
			}
		}
		$this->db->query('COMMIT');
		return null;
	}
}
?>